diff --git a/board/mpl/common/common_util.c b/board/mpl/common/common_util.c
index 6b96bd526e80..5626ecdf8b48 100644
--- a/board/mpl/common/common_util.c
+++ b/board/mpl/common/common_util.c
@@ -8,7 +8,7 @@
 #include <common.h>
 #include <command.h>
 #include <video_fb.h>
-#include "common_util.h"
+#include <board-common/common_util.h>
 #include <asm/processor.h>
 #include <asm/byteorder.h>
 #include <i2c.h>
diff --git a/board/mpl/common/common_util.h b/board/mpl/common/include/board-common/common_util.h
similarity index 100%
rename from board/mpl/common/common_util.h
rename to board/mpl/common/include/board-common/common_util.h
diff --git a/board/mpl/common/isa.h b/board/mpl/common/include/board-common/isa.h
similarity index 100%
rename from board/mpl/common/isa.h
rename to board/mpl/common/include/board-common/isa.h
diff --git a/board/mpl/common/isa.c b/board/mpl/common/isa.c
index 54ec66bd45b0..83628bba5d58 100644
--- a/board/mpl/common/isa.c
+++ b/board/mpl/common/isa.c
@@ -10,7 +10,7 @@
 #include <common.h>
 #include <asm/processor.h>
 #include <stdio_dev.h>
-#include "isa.h"
+#include <board-common/isa.h>
 #include "piix4_pci.h"
 #include "kbd.h"
 #include "video.h"
diff --git a/board/mpl/common/kbd.c b/board/mpl/common/kbd.c
index 1da72c53989c..cdcee1907dca 100644
--- a/board/mpl/common/kbd.c
+++ b/board/mpl/common/kbd.c
@@ -10,7 +10,7 @@
 #include <common.h>
 #include <asm/processor.h>
 #include <stdio_dev.h>
-#include "isa.h"
+#include <board-common/isa.h>
 #include "kbd.h"
 
 
diff --git a/board/mpl/common/pci.c b/board/mpl/common/pci.c
index cd969cb5182d..ff1822d1cc6f 100644
--- a/board/mpl/common/pci.c
+++ b/board/mpl/common/pci.c
@@ -10,7 +10,7 @@
 
 #include <common.h>
 #include <pci.h>
-#include "isa.h"
+#include <board-common/isa.h>
 
 #ifdef CONFIG_405GP
 #ifdef CONFIG_PCI
diff --git a/board/mpl/mip405/cmd_mip405.c b/board/mpl/mip405/cmd_mip405.c
index ca6f0affe48f..d71e6dbd3fbc 100644
--- a/board/mpl/mip405/cmd_mip405.c
+++ b/board/mpl/mip405/cmd_mip405.c
@@ -10,7 +10,7 @@
 #include <common.h>
 #include <command.h>
 #include "mip405.h"
-#include "../common/common_util.h"
+#include <board-common/common_util.h>
 
 
 extern void print_mip405_info(void);
diff --git a/board/mpl/mip405/mip405.c b/board/mpl/mip405/mip405.c
index 4a0d6966a6fa..e762f57ea1a1 100644
--- a/board/mpl/mip405/mip405.c
+++ b/board/mpl/mip405/mip405.c
@@ -51,7 +51,7 @@
 #include <asm/ppc4xx.h>
 #include <asm/ppc4xx-i2c.h>
 #include <miiphy.h>
-#include "../common/common_util.h"
+#include <board-common/common_util.h>
 #include <stdio_dev.h>
 #include <i2c.h>
 #include <rtc.h>
diff --git a/board/mpl/pip405/cmd_pip405.c b/board/mpl/pip405/cmd_pip405.c
index 43b182e57ebb..5a6e49ef07dd 100644
--- a/board/mpl/pip405/cmd_pip405.c
+++ b/board/mpl/pip405/cmd_pip405.c
@@ -10,7 +10,7 @@
 #include <common.h>
 #include <command.h>
 #include "pip405.h"
-#include "../common/common_util.h"
+#include <board-common/common_util.h>
 
 
 extern void print_pip405_info(void);
diff --git a/board/mpl/pip405/pip405.c b/board/mpl/pip405/pip405.c
index 7c7690ff555b..e46e8be9d9dd 100644
--- a/board/mpl/pip405/pip405.c
+++ b/board/mpl/pip405/pip405.c
@@ -12,8 +12,8 @@
 #include <asm/processor.h>
 #include <i2c.h>
 #include <stdio_dev.h>
-#include "../common/isa.h"
-#include "../common/common_util.h"
+#include <board-common/isa.h>
+#include <board-common/common_util.h>
 
 DECLARE_GLOBAL_DATA_PTR;
 
diff --git a/board/mpl/vcma9/cmd_vcma9.c b/board/mpl/vcma9/cmd_vcma9.c
index c2d62e4aaf4b..c70ae90e0b06 100644
--- a/board/mpl/vcma9/cmd_vcma9.c
+++ b/board/mpl/vcma9/cmd_vcma9.c
@@ -12,7 +12,7 @@
 #include <command.h>
 #include <net.h>
 #include "vcma9.h"
-#include "../common/common_util.h"
+#include <board-common/common_util.h>
 
 #if defined(CONFIG_CS8900)
 #include <../drivers/net/cs8900.h>
diff --git a/board/mpl/vcma9/vcma9.c b/board/mpl/vcma9/vcma9.c
index 43a3d47d2b03..2ddba0539837 100644
--- a/board/mpl/vcma9/vcma9.c
+++ b/board/mpl/vcma9/vcma9.c
@@ -16,7 +16,7 @@
 #include <asm/arch/s3c24x0_cpu.h>
 
 #include "vcma9.h"
-#include "../common/common_util.h"
+#include <board-common/common_util.h>
 
 DECLARE_GLOBAL_DATA_PTR;
 